/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/OCL/Import ecore_0='http://www.eclipse.org/emf/2002/Ecore#/' repository_0='repository.ecore#/' servicebehavior_0='servicebehavior.ecore#/' functions_0='functions.ecore#/' core_0='/resource/edu.kit.ipd.descartes.core/model/core.ecore#/'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore invocationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' settingDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot' validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot'"
 * @generated
 */
public interface ParameterdependenciesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "parameterdependencies";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.descartes-research.net/metamodel/parameterdependencies/0.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "parameterdependencies";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ParameterdependenciesPackage eINSTANCE = edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl.init();

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl <em>Model Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariable()
	 * @generated
	 */
	int MODEL_VARIABLE = 0;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_VARIABLE__SCOPE_SET = 0;

	/**
	 * The number of structural features of the '<em>Model Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_VARIABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl <em>Control Flow Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getControlFlowVariable()
	 * @generated
	 */
	int CONTROL_FLOW_VARIABLE = 3;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencedVariableReferenceImpl <em>Influenced Variable Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencedVariableReferenceImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getInfluencedVariableReference()
	 * @generated
	 */
	int INFLUENCED_VARIABLE_REFERENCE = 4;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencingParameterImpl <em>Influencing Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencingParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getInfluencingParameter()
	 * @generated
	 */
	int INFLUENCING_PARAMETER = 5;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl <em>Shadow Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getShadowParameter()
	 * @generated
	 */
	int SHADOW_PARAMETER = 6;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl <em>Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationship()
	 * @generated
	 */
	int RELATIONSHIP = 7;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl <em>Dependency Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getDependencyRelationship()
	 * @generated
	 */
	int DEPENDENCY_RELATIONSHIP = 8;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl <em>Correlation Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getCorrelationRelationship()
	 * @generated
	 */
	int CORRELATION_RELATIONSHIP = 9;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl <em>Component Instance Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getComponentInstanceReference()
	 * @generated
	 */
	int COMPONENT_INSTANCE_REFERENCE = 10;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl <em>Scope Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScopeSet()
	 * @generated
	 */
	int SCOPE_SET = 1;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_SET__SCOPE = 0;

	/**
	 * The number of structural features of the '<em>Scope Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_SET_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeImpl <em>Scope</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScope()
	 * @generated
	 */
	int SCOPE = 2;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE__SCOPE = 0;

	/**
	 * The number of structural features of the '<em>Scope</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCOPE_FEATURE_COUNT = 1;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__SCOPE_SET = MODEL_VARIABLE__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__CHARACTERIZATION = MODEL_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION = MODEL_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Control Flow Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_VARIABLE_FEATURE_COUNT = MODEL_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Get Influenced Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCED_VARIABLE_REFERENCE__GET_INFLUENCED_VARIABLE = 0;

	/**
	 * The feature id for the '<em><b>Control Flow Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCED_VARIABLE_REFERENCE__CONTROL_FLOW_VARIABLE = 1;

	/**
	 * The feature id for the '<em><b>Resource Demand</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCED_VARIABLE_REFERENCE__RESOURCE_DEMAND = 2;

	/**
	 * The feature id for the '<em><b>Response Time</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCED_VARIABLE_REFERENCE__RESPONSE_TIME = 3;

	/**
	 * The number of structural features of the '<em>Influenced Variable Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCED_VARIABLE_REFERENCE_FEATURE_COUNT = 4;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCING_PARAMETER__SCOPE_SET = MODEL_VARIABLE__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCING_PARAMETER__BEHAVIOR = MODEL_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Influencing Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INFLUENCING_PARAMETER_FEATURE_COUNT = MODEL_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__SCOPE_SET = INFLUENCING_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__BEHAVIOR = INFLUENCING_PARAMETER__BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__NAME = INFLUENCING_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER__DESCRIPTION = INFLUENCING_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Shadow Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHADOW_PARAMETER_FEATURE_COUNT = INFLUENCING_PARAMETER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Surrounding Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__SURROUNDING_ENTITY = 0;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__CHARACTERIZATION = 1;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__EXPLICIT_DESCRIPTION = 2;

	/**
	 * The number of structural features of the '<em>Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_FEATURE_COUNT = 3;

	/**
	 * The feature id for the '<em><b>Surrounding Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__SURROUNDING_ENTITY = RELATIONSHIP__SURROUNDING_ENTITY;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__CHARACTERIZATION = RELATIONSHIP__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__EXPLICIT_DESCRIPTION = RELATIONSHIP__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__DESTINATION = RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Sources</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP__SOURCES = RELATIONSHIP_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Dependency Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_RELATIONSHIP_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Surrounding Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__SURROUNDING_ENTITY = RELATIONSHIP__SURROUNDING_ENTITY;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__CHARACTERIZATION = RELATIONSHIP__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__EXPLICIT_DESCRIPTION = RELATIONSHIP__EXPLICIT_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Sources</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__SOURCES = RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Destination</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__DESTINATION = RELATIONSHIP_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Source Component Instance References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES = RELATIONSHIP_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Destination Component Instance Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE = RELATIONSHIP_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Correlation Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CORRELATION_RELATIONSHIP_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Assemblies</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_INSTANCE_REFERENCE__ASSEMBLIES = 0;

	/**
	 * The number of structural features of the '<em>Component Instance Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_INSTANCE_REFERENCE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl <em>Call Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getCallParameter()
	 * @generated
	 */
	int CALL_PARAMETER = 11;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__SCOPE_SET = INFLUENCING_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__BEHAVIOR = INFLUENCING_PARAMETER__BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__CHARACTERIZATION = INFLUENCING_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__SIGNATURE = INFLUENCING_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__PARAMETER = INFLUENCING_PARAMETER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER__RETURN_TYPE = INFLUENCING_PARAMETER_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Call Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_PARAMETER_FEATURE_COUNT = INFLUENCING_PARAMETER_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl <em>Service Input Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getServiceInputParameter()
	 * @generated
	 */
	int SERVICE_INPUT_PARAMETER = 12;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__BEHAVIOR = CALL_PARAMETER__BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__SIGNATURE = CALL_PARAMETER__SIGNATURE;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__PARAMETER = CALL_PARAMETER__PARAMETER;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__RETURN_TYPE = CALL_PARAMETER__RETURN_TYPE;

	/**
	 * The feature id for the '<em><b>Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER__PROVIDING_ROLE = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Service Input Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_INPUT_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl <em>External Call Return Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallReturnParameter()
	 * @generated
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER = 13;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__BEHAVIOR = CALL_PARAMETER__BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__SIGNATURE = CALL_PARAMETER__SIGNATURE;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__PARAMETER = CALL_PARAMETER__PARAMETER;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__RETURN_TYPE = CALL_PARAMETER__RETURN_TYPE;

	/**
	 * The feature id for the '<em><b>External Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER__EXTERNAL_CALL = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>External Call Return Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_RETURN_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl <em>External Call Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallParameter()
	 * @generated
	 */
	int EXTERNAL_CALL_PARAMETER = 14;

	/**
	 * The feature id for the '<em><b>Scope Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__SCOPE_SET = CALL_PARAMETER__SCOPE_SET;

	/**
	 * The feature id for the '<em><b>Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__BEHAVIOR = CALL_PARAMETER__BEHAVIOR;

	/**
	 * The feature id for the '<em><b>Characterization</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__CHARACTERIZATION = CALL_PARAMETER__CHARACTERIZATION;

	/**
	 * The feature id for the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__SIGNATURE = CALL_PARAMETER__SIGNATURE;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__PARAMETER = CALL_PARAMETER__PARAMETER;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__RETURN_TYPE = CALL_PARAMETER__RETURN_TYPE;

	/**
	 * The feature id for the '<em><b>Externall Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER__EXTERNALL_CALL = CALL_PARAMETER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>External Call Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALL_PARAMETER_FEATURE_COUNT = CALL_PARAMETER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType <em>Model Variable Characterization Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariableCharacterizationType()
	 * @generated
	 */
	int MODEL_VARIABLE_CHARACTERIZATION_TYPE = 15;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType <em>Relationship Characterization Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationshipCharacterizationType()
	 * @generated
	 */
	int RELATIONSHIP_CHARACTERIZATION_TYPE = 16;

	/**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType <em>Parameter Characterization Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getParameterCharacterizationType()
	 * @generated
	 */
	int PARAMETER_CHARACTERIZATION_TYPE = 17;


	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariable <em>Model Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Variable</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariable
	 * @generated
	 */
	EClass getModelVariable();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariable#getScopeSet <em>Scope Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Scope Set</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariable#getScopeSet()
	 * @see #getModelVariable()
	 * @generated
	 */
	EReference getModelVariable_ScopeSet();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable <em>Control Flow Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control Flow Variable</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable
	 * @generated
	 */
	EClass getControlFlowVariable();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getCharacterization <em>Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Characterization</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getCharacterization()
	 * @see #getControlFlowVariable()
	 * @generated
	 */
	EAttribute getControlFlowVariable_Characterization();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getExplicitDescription <em>Explicit Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Explicit Description</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getExplicitDescription()
	 * @see #getControlFlowVariable()
	 * @generated
	 */
	EReference getControlFlowVariable_ExplicitDescription();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference <em>Influenced Variable Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Influenced Variable Reference</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference
	 * @generated
	 */
	EClass getInfluencedVariableReference();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getGetInfluencedVariable <em>Get Influenced Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Get Influenced Variable</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getGetInfluencedVariable()
	 * @see #getInfluencedVariableReference()
	 * @generated
	 */
	EReference getInfluencedVariableReference_GetInfluencedVariable();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getControlFlowVariable <em>Control Flow Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Control Flow Variable</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getControlFlowVariable()
	 * @see #getInfluencedVariableReference()
	 * @generated
	 */
	EReference getInfluencedVariableReference_ControlFlowVariable();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResourceDemand <em>Resource Demand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Resource Demand</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResourceDemand()
	 * @see #getInfluencedVariableReference()
	 * @generated
	 */
	EReference getInfluencedVariableReference_ResourceDemand();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResponseTime <em>Response Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Response Time</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference#getResponseTime()
	 * @see #getInfluencedVariableReference()
	 * @generated
	 */
	EReference getInfluencedVariableReference_ResponseTime();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter <em>Influencing Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Influencing Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter
	 * @generated
	 */
	EClass getInfluencingParameter();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter#getBehavior <em>Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Behavior</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter#getBehavior()
	 * @see #getInfluencingParameter()
	 * @generated
	 */
	EReference getInfluencingParameter_Behavior();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter <em>Shadow Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Shadow Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter
	 * @generated
	 */
	EClass getShadowParameter();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter#getName()
	 * @see #getShadowParameter()
	 * @generated
	 */
	EAttribute getShadowParameter_Name();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ShadowParameter#getDescription()
	 * @see #getShadowParameter()
	 * @generated
	 */
	EAttribute getShadowParameter_Description();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship
	 * @generated
	 */
	EClass getRelationship();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship#getSurroundingEntity <em>Surrounding Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Surrounding Entity</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship#getSurroundingEntity()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_SurroundingEntity();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship#getCharacterization <em>Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Characterization</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship#getCharacterization()
	 * @see #getRelationship()
	 * @generated
	 */
	EAttribute getRelationship_Characterization();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship#getExplicitDescription <em>Explicit Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Explicit Description</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship#getExplicitDescription()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_ExplicitDescription();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship <em>Dependency Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency Relationship</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship
	 * @generated
	 */
	EClass getDependencyRelationship();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getDestination <em>Destination</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Destination</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getDestination()
	 * @see #getDependencyRelationship()
	 * @generated
	 */
	EReference getDependencyRelationship_Destination();

	/**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getSources <em>Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sources</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship#getSources()
	 * @see #getDependencyRelationship()
	 * @generated
	 */
	EReference getDependencyRelationship_Sources();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship <em>Correlation Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Correlation Relationship</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship
	 * @generated
	 */
	EClass getCorrelationRelationship();

	/**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getSources <em>Sources</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sources</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getSources()
	 * @see #getCorrelationRelationship()
	 * @generated
	 */
	EReference getCorrelationRelationship_Sources();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestination <em>Destination</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Destination</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestination()
	 * @see #getCorrelationRelationship()
	 * @generated
	 */
	EReference getCorrelationRelationship_Destination();

	/**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getSourceComponentInstanceReferences <em>Source Component Instance References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Source Component Instance References</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getSourceComponentInstanceReferences()
	 * @see #getCorrelationRelationship()
	 * @generated
	 */
	EReference getCorrelationRelationship_SourceComponentInstanceReferences();

	/**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestinationComponentInstanceReference <em>Destination Component Instance Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Destination Component Instance Reference</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestinationComponentInstanceReference()
	 * @see #getCorrelationRelationship()
	 * @generated
	 */
	EReference getCorrelationRelationship_DestinationComponentInstanceReference();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference <em>Component Instance Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Instance Reference</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference
	 * @generated
	 */
	EClass getComponentInstanceReference();

	/**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference#getAssemblies <em>Assemblies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Assemblies</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference#getAssemblies()
	 * @see #getComponentInstanceReference()
	 * @generated
	 */
	EReference getComponentInstanceReference_Assemblies();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ScopeSet <em>Scope Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scope Set</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ScopeSet
	 * @generated
	 */
	EClass getScopeSet();

	/**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ScopeSet#getScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Scope</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ScopeSet#getScope()
	 * @see #getScopeSet()
	 * @generated
	 */
	EReference getScopeSet_Scope();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Scope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scope</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Scope
	 * @generated
	 */
	EClass getScope();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Scope#getScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Scope</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Scope#getScope()
	 * @see #getScope()
	 * @generated
	 */
	EReference getScope_Scope();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter <em>Call Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter
	 * @generated
	 */
	EClass getCallParameter();

	/**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getCharacterization <em>Characterization</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Characterization</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getCharacterization()
	 * @see #getCallParameter()
	 * @generated
	 */
	EAttribute getCallParameter_Characterization();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getSignature <em>Signature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Signature</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getSignature()
	 * @see #getCallParameter()
	 * @generated
	 */
	EReference getCallParameter_Signature();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getParameter()
	 * @see #getCallParameter()
	 * @generated
	 */
	EReference getCallParameter_Parameter();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getReturnType <em>Return Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Return Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CallParameter#getReturnType()
	 * @see #getCallParameter()
	 * @generated
	 */
	EReference getCallParameter_ReturnType();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ServiceInputParameter <em>Service Input Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service Input Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ServiceInputParameter
	 * @generated
	 */
	EClass getServiceInputParameter();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ServiceInputParameter#getProvidingRole <em>Providing Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Providing Role</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ServiceInputParameter#getProvidingRole()
	 * @see #getServiceInputParameter()
	 * @generated
	 */
	EReference getServiceInputParameter_ProvidingRole();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter <em>External Call Return Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Call Return Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter
	 * @generated
	 */
	EClass getExternalCallReturnParameter();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter#getExternalCall <em>External Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>External Call</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallReturnParameter#getExternalCall()
	 * @see #getExternalCallReturnParameter()
	 * @generated
	 */
	EReference getExternalCallReturnParameter_ExternalCall();

	/**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallParameter <em>External Call Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Call Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallParameter
	 * @generated
	 */
	EClass getExternalCallParameter();

	/**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallParameter#getExternallCall <em>Externall Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Externall Call</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ExternalCallParameter#getExternallCall()
	 * @see #getExternalCallParameter()
	 * @generated
	 */
	EReference getExternalCallParameter_ExternallCall();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType <em>Model Variable Characterization Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Model Variable Characterization Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @generated
	 */
	EEnum getModelVariableCharacterizationType();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType <em>Relationship Characterization Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Relationship Characterization Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
	 * @generated
	 */
	EEnum getRelationshipCharacterizationType();

	/**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType <em>Parameter Characterization Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Parameter Characterization Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
	 * @generated
	 */
	EEnum getParameterCharacterizationType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ParameterdependenciesFactory getParameterdependenciesFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl <em>Model Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariable()
		 * @generated
		 */
		EClass MODEL_VARIABLE = eINSTANCE.getModelVariable();

		/**
		 * The meta object literal for the '<em><b>Scope Set</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_VARIABLE__SCOPE_SET = eINSTANCE.getModelVariable_ScopeSet();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl <em>Control Flow Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getControlFlowVariable()
		 * @generated
		 */
		EClass CONTROL_FLOW_VARIABLE = eINSTANCE.getControlFlowVariable();

		/**
		 * The meta object literal for the '<em><b>Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONTROL_FLOW_VARIABLE__CHARACTERIZATION = eINSTANCE.getControlFlowVariable_Characterization();

		/**
		 * The meta object literal for the '<em><b>Explicit Description</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION = eINSTANCE.getControlFlowVariable_ExplicitDescription();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencedVariableReferenceImpl <em>Influenced Variable Reference</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencedVariableReferenceImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getInfluencedVariableReference()
		 * @generated
		 */
		EClass INFLUENCED_VARIABLE_REFERENCE = eINSTANCE.getInfluencedVariableReference();

		/**
		 * The meta object literal for the '<em><b>Get Influenced Variable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INFLUENCED_VARIABLE_REFERENCE__GET_INFLUENCED_VARIABLE = eINSTANCE.getInfluencedVariableReference_GetInfluencedVariable();

		/**
		 * The meta object literal for the '<em><b>Control Flow Variable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INFLUENCED_VARIABLE_REFERENCE__CONTROL_FLOW_VARIABLE = eINSTANCE.getInfluencedVariableReference_ControlFlowVariable();

		/**
		 * The meta object literal for the '<em><b>Resource Demand</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INFLUENCED_VARIABLE_REFERENCE__RESOURCE_DEMAND = eINSTANCE.getInfluencedVariableReference_ResourceDemand();

		/**
		 * The meta object literal for the '<em><b>Response Time</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INFLUENCED_VARIABLE_REFERENCE__RESPONSE_TIME = eINSTANCE.getInfluencedVariableReference_ResponseTime();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencingParameterImpl <em>Influencing Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.InfluencingParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getInfluencingParameter()
		 * @generated
		 */
		EClass INFLUENCING_PARAMETER = eINSTANCE.getInfluencingParameter();

		/**
		 * The meta object literal for the '<em><b>Behavior</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INFLUENCING_PARAMETER__BEHAVIOR = eINSTANCE.getInfluencingParameter_Behavior();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl <em>Shadow Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ShadowParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getShadowParameter()
		 * @generated
		 */
		EClass SHADOW_PARAMETER = eINSTANCE.getShadowParameter();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SHADOW_PARAMETER__NAME = eINSTANCE.getShadowParameter_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SHADOW_PARAMETER__DESCRIPTION = eINSTANCE.getShadowParameter_Description();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl <em>Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationship()
		 * @generated
		 */
		EClass RELATIONSHIP = eINSTANCE.getRelationship();

		/**
		 * The meta object literal for the '<em><b>Surrounding Entity</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__SURROUNDING_ENTITY = eINSTANCE.getRelationship_SurroundingEntity();

		/**
		 * The meta object literal for the '<em><b>Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP__CHARACTERIZATION = eINSTANCE.getRelationship_Characterization();

		/**
		 * The meta object literal for the '<em><b>Explicit Description</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__EXPLICIT_DESCRIPTION = eINSTANCE.getRelationship_ExplicitDescription();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl <em>Dependency Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getDependencyRelationship()
		 * @generated
		 */
		EClass DEPENDENCY_RELATIONSHIP = eINSTANCE.getDependencyRelationship();

		/**
		 * The meta object literal for the '<em><b>Destination</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY_RELATIONSHIP__DESTINATION = eINSTANCE.getDependencyRelationship_Destination();

		/**
		 * The meta object literal for the '<em><b>Sources</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEPENDENCY_RELATIONSHIP__SOURCES = eINSTANCE.getDependencyRelationship_Sources();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl <em>Correlation Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CorrelationRelationshipImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getCorrelationRelationship()
		 * @generated
		 */
		EClass CORRELATION_RELATIONSHIP = eINSTANCE.getCorrelationRelationship();

		/**
		 * The meta object literal for the '<em><b>Sources</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CORRELATION_RELATIONSHIP__SOURCES = eINSTANCE.getCorrelationRelationship_Sources();

		/**
		 * The meta object literal for the '<em><b>Destination</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CORRELATION_RELATIONSHIP__DESTINATION = eINSTANCE.getCorrelationRelationship_Destination();

		/**
		 * The meta object literal for the '<em><b>Source Component Instance References</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CORRELATION_RELATIONSHIP__SOURCE_COMPONENT_INSTANCE_REFERENCES = eINSTANCE.getCorrelationRelationship_SourceComponentInstanceReferences();

		/**
		 * The meta object literal for the '<em><b>Destination Component Instance Reference</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CORRELATION_RELATIONSHIP__DESTINATION_COMPONENT_INSTANCE_REFERENCE = eINSTANCE.getCorrelationRelationship_DestinationComponentInstanceReference();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl <em>Component Instance Reference</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ComponentInstanceReferenceImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getComponentInstanceReference()
		 * @generated
		 */
		EClass COMPONENT_INSTANCE_REFERENCE = eINSTANCE.getComponentInstanceReference();

		/**
		 * The meta object literal for the '<em><b>Assemblies</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_INSTANCE_REFERENCE__ASSEMBLIES = eINSTANCE.getComponentInstanceReference_Assemblies();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl <em>Scope Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeSetImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScopeSet()
		 * @generated
		 */
		EClass SCOPE_SET = eINSTANCE.getScopeSet();

		/**
		 * The meta object literal for the '<em><b>Scope</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE_SET__SCOPE = eINSTANCE.getScopeSet_Scope();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeImpl <em>Scope</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ScopeImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getScope()
		 * @generated
		 */
		EClass SCOPE = eINSTANCE.getScope();

		/**
		 * The meta object literal for the '<em><b>Scope</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCOPE__SCOPE = eINSTANCE.getScope_Scope();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl <em>Call Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.CallParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getCallParameter()
		 * @generated
		 */
		EClass CALL_PARAMETER = eINSTANCE.getCallParameter();

		/**
		 * The meta object literal for the '<em><b>Characterization</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL_PARAMETER__CHARACTERIZATION = eINSTANCE.getCallParameter_Characterization();

		/**
		 * The meta object literal for the '<em><b>Signature</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL_PARAMETER__SIGNATURE = eINSTANCE.getCallParameter_Signature();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL_PARAMETER__PARAMETER = eINSTANCE.getCallParameter_Parameter();

		/**
		 * The meta object literal for the '<em><b>Return Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL_PARAMETER__RETURN_TYPE = eINSTANCE.getCallParameter_ReturnType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl <em>Service Input Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ServiceInputParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getServiceInputParameter()
		 * @generated
		 */
		EClass SERVICE_INPUT_PARAMETER = eINSTANCE.getServiceInputParameter();

		/**
		 * The meta object literal for the '<em><b>Providing Role</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERVICE_INPUT_PARAMETER__PROVIDING_ROLE = eINSTANCE.getServiceInputParameter_ProvidingRole();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl <em>External Call Return Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallReturnParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallReturnParameter()
		 * @generated
		 */
		EClass EXTERNAL_CALL_RETURN_PARAMETER = eINSTANCE.getExternalCallReturnParameter();

		/**
		 * The meta object literal for the '<em><b>External Call</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALL_RETURN_PARAMETER__EXTERNAL_CALL = eINSTANCE.getExternalCallReturnParameter_ExternalCall();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl <em>External Call Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ExternalCallParameterImpl
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getExternalCallParameter()
		 * @generated
		 */
		EClass EXTERNAL_CALL_PARAMETER = eINSTANCE.getExternalCallParameter();

		/**
		 * The meta object literal for the '<em><b>Externall Call</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALL_PARAMETER__EXTERNALL_CALL = eINSTANCE.getExternalCallParameter_ExternallCall();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType <em>Model Variable Characterization Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getModelVariableCharacterizationType()
		 * @generated
		 */
		EEnum MODEL_VARIABLE_CHARACTERIZATION_TYPE = eINSTANCE.getModelVariableCharacterizationType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType <em>Relationship Characterization Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getRelationshipCharacterizationType()
		 * @generated
		 */
		EEnum RELATIONSHIP_CHARACTERIZATION_TYPE = eINSTANCE.getRelationshipCharacterizationType();

		/**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType <em>Parameter Characterization Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterCharacterizationType
		 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ParameterdependenciesPackageImpl#getParameterCharacterizationType()
		 * @generated
		 */
		EEnum PARAMETER_CHARACTERIZATION_TYPE = eINSTANCE.getParameterCharacterizationType();

	}

} //ParameterdependenciesPackage
