/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ParameterdependenciesFactoryImpl extends EFactoryImpl implements ParameterdependenciesFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ParameterdependenciesFactory init() {
		try {
			ParameterdependenciesFactory theParameterdependenciesFactory = (ParameterdependenciesFactory)EPackage.Registry.INSTANCE.getEFactory(ParameterdependenciesPackage.eNS_URI);
			if (theParameterdependenciesFactory != null) {
				return theParameterdependenciesFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ParameterdependenciesFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParameterdependenciesFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ParameterdependenciesPackage.SCOPE_SET: return createScopeSet();
			case ParameterdependenciesPackage.SCOPE: return createScope();
			case ParameterdependenciesPackage.INFLUENCED_VARIABLE_REFERENCE: return createInfluencedVariableReference();
			case ParameterdependenciesPackage.SHADOW_PARAMETER: return createShadowParameter();
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP: return createDependencyRelationship();
			case ParameterdependenciesPackage.CORRELATION_RELATIONSHIP: return createCorrelationRelationship();
			case ParameterdependenciesPackage.COMPONENT_INSTANCE_REFERENCE: return createComponentInstanceReference();
			case ParameterdependenciesPackage.SERVICE_INPUT_PARAMETER: return createServiceInputParameter();
			case ParameterdependenciesPackage.EXTERNAL_CALL_RETURN_PARAMETER: return createExternalCallReturnParameter();
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER: return createExternalCallParameter();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case ParameterdependenciesPackage.MODEL_VARIABLE_CHARACTERIZATION_TYPE:
				return createModelVariableCharacterizationTypeFromString(eDataType, initialValue);
			case ParameterdependenciesPackage.RELATIONSHIP_CHARACTERIZATION_TYPE:
				return createRelationshipCharacterizationTypeFromString(eDataType, initialValue);
			case ParameterdependenciesPackage.PARAMETER_CHARACTERIZATION_TYPE:
				return createParameterCharacterizationTypeFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case ParameterdependenciesPackage.MODEL_VARIABLE_CHARACTERIZATION_TYPE:
				return convertModelVariableCharacterizationTypeToString(eDataType, instanceValue);
			case ParameterdependenciesPackage.RELATIONSHIP_CHARACTERIZATION_TYPE:
				return convertRelationshipCharacterizationTypeToString(eDataType, instanceValue);
			case ParameterdependenciesPackage.PARAMETER_CHARACTERIZATION_TYPE:
				return convertParameterCharacterizationTypeToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencedVariableReference createInfluencedVariableReference() {
		InfluencedVariableReferenceImpl influencedVariableReference = new InfluencedVariableReferenceImpl();
		return influencedVariableReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ShadowParameter createShadowParameter() {
		ShadowParameterImpl shadowParameter = new ShadowParameterImpl();
		return shadowParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DependencyRelationship createDependencyRelationship() {
		DependencyRelationshipImpl dependencyRelationship = new DependencyRelationshipImpl();
		return dependencyRelationship;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CorrelationRelationship createCorrelationRelationship() {
		CorrelationRelationshipImpl correlationRelationship = new CorrelationRelationshipImpl();
		return correlationRelationship;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentInstanceReference createComponentInstanceReference() {
		ComponentInstanceReferenceImpl componentInstanceReference = new ComponentInstanceReferenceImpl();
		return componentInstanceReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScopeSet createScopeSet() {
		ScopeSetImpl scopeSet = new ScopeSetImpl();
		return scopeSet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Scope createScope() {
		ScopeImpl scope = new ScopeImpl();
		return scope;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServiceInputParameter createServiceInputParameter() {
		ServiceInputParameterImpl serviceInputParameter = new ServiceInputParameterImpl();
		return serviceInputParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExternalCallReturnParameter createExternalCallReturnParameter() {
		ExternalCallReturnParameterImpl externalCallReturnParameter = new ExternalCallReturnParameterImpl();
		return externalCallReturnParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExternalCallParameter createExternalCallParameter() {
		ExternalCallParameterImpl externalCallParameter = new ExternalCallParameterImpl();
		return externalCallParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelVariableCharacterizationType createModelVariableCharacterizationTypeFromString(EDataType eDataType, String initialValue) {
		ModelVariableCharacterizationType result = ModelVariableCharacterizationType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertModelVariableCharacterizationTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationshipCharacterizationType createRelationshipCharacterizationTypeFromString(EDataType eDataType, String initialValue) {
		RelationshipCharacterizationType result = RelationshipCharacterizationType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRelationshipCharacterizationTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParameterCharacterizationType createParameterCharacterizationTypeFromString(EDataType eDataType, String initialValue) {
		ParameterCharacterizationType result = ParameterCharacterizationType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertParameterCharacterizationTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParameterdependenciesPackage getParameterdependenciesPackage() {
		return (ParameterdependenciesPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ParameterdependenciesPackage getPackage() {
		return ParameterdependenciesPackage.eINSTANCE;
	}

} //ParameterdependenciesFactoryImpl
