/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Characterization;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.Relationship;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.RelationshipCharacterizationType;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Relationship</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getSurroundingEntity <em>Surrounding Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.RelationshipImpl#getExplicitDescription <em>Explicit Description</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class RelationshipImpl extends EObjectImpl implements Relationship {
	/**
	 * The cached value of the '{@link #getSurroundingEntity() <em>Surrounding Entity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSurroundingEntity()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRequiringEntity surroundingEntity;

	/**
	 * The default value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected static final RelationshipCharacterizationType CHARACTERIZATION_EDEFAULT = RelationshipCharacterizationType.EMPIRICAL;

	/**
	 * The cached value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected RelationshipCharacterizationType characterization = CHARACTERIZATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExplicitDescription() <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExplicitDescription()
	 * @generated
	 * @ordered
	 */
	protected ExplicitDescription explicitDescription;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RelationshipImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.RELATIONSHIP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRequiringEntity getSurroundingEntity() {
		if (surroundingEntity != null && surroundingEntity.eIsProxy()) {
			InternalEObject oldSurroundingEntity = (InternalEObject)surroundingEntity;
			surroundingEntity = (InterfaceProvidingRequiringEntity)eResolveProxy(oldSurroundingEntity);
			if (surroundingEntity != oldSurroundingEntity) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY, oldSurroundingEntity, surroundingEntity));
			}
		}
		return surroundingEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRequiringEntity basicGetSurroundingEntity() {
		return surroundingEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSurroundingEntity(InterfaceProvidingRequiringEntity newSurroundingEntity) {
		InterfaceProvidingRequiringEntity oldSurroundingEntity = surroundingEntity;
		surroundingEntity = newSurroundingEntity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY, oldSurroundingEntity, surroundingEntity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationshipCharacterizationType getCharacterization() {
		return characterization;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCharacterization(RelationshipCharacterizationType newCharacterization) {
		RelationshipCharacterizationType oldCharacterization = characterization;
		characterization = newCharacterization == null ? CHARACTERIZATION_EDEFAULT : newCharacterization;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION, oldCharacterization, characterization));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExplicitDescription getExplicitDescription() {
		return explicitDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExplicitDescription(ExplicitDescription newExplicitDescription, NotificationChain msgs) {
		ExplicitDescription oldExplicitDescription = explicitDescription;
		explicitDescription = newExplicitDescription;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, oldExplicitDescription, newExplicitDescription);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExplicitDescription(ExplicitDescription newExplicitDescription) {
		if (newExplicitDescription != explicitDescription) {
			NotificationChain msgs = null;
			if (explicitDescription != null)
				msgs = ((InternalEObject)explicitDescription).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, null, msgs);
			if (newExplicitDescription != null)
				msgs = ((InternalEObject)newExplicitDescription).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, null, msgs);
			msgs = basicSetExplicitDescription(newExplicitDescription, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION, newExplicitDescription, newExplicitDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				return basicSetExplicitDescription(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				if (resolve) return getSurroundingEntity();
				return basicGetSurroundingEntity();
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				return getCharacterization();
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				return getExplicitDescription();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				setSurroundingEntity((InterfaceProvidingRequiringEntity)newValue);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				setCharacterization((RelationshipCharacterizationType)newValue);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				setExplicitDescription((ExplicitDescription)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				setSurroundingEntity((InterfaceProvidingRequiringEntity)null);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				setCharacterization(CHARACTERIZATION_EDEFAULT);
				return;
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				setExplicitDescription((ExplicitDescription)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.RELATIONSHIP__SURROUNDING_ENTITY:
				return surroundingEntity != null;
			case ParameterdependenciesPackage.RELATIONSHIP__CHARACTERIZATION:
				return characterization != CHARACTERIZATION_EDEFAULT;
			case ParameterdependenciesPackage.RELATIONSHIP__EXPLICIT_DESCRIPTION:
				return explicitDescription != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (characterization: ");
		result.append(characterization);
		result.append(')');
		return result.toString();
	}

} //RelationshipImpl
