/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

import edu.kit.ipd.descartes.mm.workload.BranchUserAction;
import edu.kit.ipd.descartes.mm.workload.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.workload.WorkloadPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Branch User Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.BranchUserActionImpl#getBranches <em>Branches</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.BranchUserActionImpl#getBranchUserProbabilities <em>Branch User Probabilities</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BranchUserActionImpl extends AbstractUserActionImpl implements BranchUserAction {
	/**
	 * The cached value of the '{@link #getBranches() <em>Branches</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBranches()
	 * @generated
	 * @ordered
	 */
	protected EList<ScenarioBehavior> branches;

	/**
	 * The cached value of the '{@link #getBranchUserProbabilities() <em>Branch User Probabilities</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBranchUserProbabilities()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable branchUserProbabilities;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BranchUserActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return WorkloadPackage.Literals.BRANCH_USER_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ScenarioBehavior> getBranches() {
		if (branches == null) {
			branches = new EObjectContainmentEList<ScenarioBehavior>(ScenarioBehavior.class, this, WorkloadPackage.BRANCH_USER_ACTION__BRANCHES);
		}
		return branches;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable getBranchUserProbabilities() {
		return branchUserProbabilities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBranchUserProbabilities(RandomVariable newBranchUserProbabilities, NotificationChain msgs) {
		RandomVariable oldBranchUserProbabilities = branchUserProbabilities;
		branchUserProbabilities = newBranchUserProbabilities;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES, oldBranchUserProbabilities, newBranchUserProbabilities);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBranchUserProbabilities(RandomVariable newBranchUserProbabilities) {
		if (newBranchUserProbabilities != branchUserProbabilities) {
			NotificationChain msgs = null;
			if (branchUserProbabilities != null)
				msgs = ((InternalEObject)branchUserProbabilities).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES, null, msgs);
			if (newBranchUserProbabilities != null)
				msgs = ((InternalEObject)newBranchUserProbabilities).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES, null, msgs);
			msgs = basicSetBranchUserProbabilities(newBranchUserProbabilities, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES, newBranchUserProbabilities, newBranchUserProbabilities));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCHES:
				return ((InternalEList<?>)getBranches()).basicRemove(otherEnd, msgs);
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES:
				return basicSetBranchUserProbabilities(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCHES:
				return getBranches();
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES:
				return getBranchUserProbabilities();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCHES:
				getBranches().clear();
				getBranches().addAll((Collection<? extends ScenarioBehavior>)newValue);
				return;
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES:
				setBranchUserProbabilities((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCHES:
				getBranches().clear();
				return;
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES:
				setBranchUserProbabilities((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCHES:
				return branches != null && !branches.isEmpty();
			case WorkloadPackage.BRANCH_USER_ACTION__BRANCH_USER_PROBABILITIES:
				return branchUserProbabilities != null;
		}
		return super.eIsSet(featureID);
	}

} //BranchUserActionImpl
