/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.util;

import edu.kit.ipd.descartes.identifier.util.IdentifierValidator;

import edu.kit.ipd.descartes.mm.workload.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.workload.WorkloadPackage
 * @generated
 */
public class WorkloadValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final WorkloadValidator INSTANCE = new WorkloadValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "edu.kit.ipd.descartes.mm.workload";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IdentifierValidator identifierValidator;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkloadValidator() {
		super();
		identifierValidator = IdentifierValidator.INSTANCE;
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return WorkloadPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case WorkloadPackage.WORKLOAD:
				return validateWorkload((Workload)value, diagnostics, context);
			case WorkloadPackage.USAGE_SCENARIO:
				return validateUsageScenario((UsageScenario)value, diagnostics, context);
			case WorkloadPackage.SCENARIO_BEHAVIOR:
				return validateScenarioBehavior((ScenarioBehavior)value, diagnostics, context);
			case WorkloadPackage.WORKLOAD_TYPE:
				return validateWorkloadType((WorkloadType)value, diagnostics, context);
			case WorkloadPackage.OPEN_WORKLOAD_TYPE:
				return validateOpenWorkloadType((OpenWorkloadType)value, diagnostics, context);
			case WorkloadPackage.CLOSED_WORKLOAD_TYPE:
				return validateClosedWorkloadType((ClosedWorkloadType)value, diagnostics, context);
			case WorkloadPackage.ABSTRACT_USER_ACTION:
				return validateAbstractUserAction((AbstractUserAction)value, diagnostics, context);
			case WorkloadPackage.LOOP_USER_ACTION:
				return validateLoopUserAction((LoopUserAction)value, diagnostics, context);
			case WorkloadPackage.DELAY_USER_ACTION:
				return validateDelayUserAction((DelayUserAction)value, diagnostics, context);
			case WorkloadPackage.BRANCH_USER_ACTION:
				return validateBranchUserAction((BranchUserAction)value, diagnostics, context);
			case WorkloadPackage.ENTRY_LEVEL_SYSTEM_CALL:
				return validateEntryLevelSystemCall((EntryLevelSystemCall)value, diagnostics, context);
			case WorkloadPackage.CALL_PARAMETER_SETTING:
				return validateCallParameterSetting((CallParameterSetting)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateWorkload(Workload workload, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(workload, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(workload, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(workload, diagnostics, context);
		if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(workload, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateUsageScenario(UsageScenario usageScenario, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(usageScenario, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(usageScenario, diagnostics, context);
		if (result || diagnostics != null) result &= identifierValidator.validateIdentifier_idHasToBeUnique(usageScenario, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateScenarioBehavior(ScenarioBehavior scenarioBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(scenarioBehavior, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateWorkloadType(WorkloadType workloadType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(workloadType, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateOpenWorkloadType(OpenWorkloadType openWorkloadType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(openWorkloadType, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(openWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validateOpenWorkloadType_interArrivalTimeInOpenWorkloadNeedsToBeSpecified(openWorkloadType, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the interArrivalTimeInOpenWorkloadNeedsToBeSpecified constraint of '<em>Open Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME_IN_OPEN_WORKLOAD_NEEDS_TO_BE_SPECIFIED__EEXPRESSION = "not self.interArrivalTime.oclIsUndefined() and not self.interArrivalTime.probFunction.oclIsUndefined()";

	/**
	 * Validates the interArrivalTimeInOpenWorkloadNeedsToBeSpecified constraint of '<em>Open Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateOpenWorkloadType_interArrivalTimeInOpenWorkloadNeedsToBeSpecified(OpenWorkloadType openWorkloadType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(WorkloadPackage.Literals.OPEN_WORKLOAD_TYPE,
				 openWorkloadType,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "interArrivalTimeInOpenWorkloadNeedsToBeSpecified",
				 OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME_IN_OPEN_WORKLOAD_NEEDS_TO_BE_SPECIFIED__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateClosedWorkloadType(ClosedWorkloadType closedWorkloadType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(closedWorkloadType, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validateClosedWorkloadType_thinkTimeInClosedWorkloadNeedsToBeSpecified(closedWorkloadType, diagnostics, context);
		if (result || diagnostics != null) result &= validateClosedWorkloadType_populationInClosedWorkloadNeedsToBeGreaterThanZero(closedWorkloadType, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the thinkTimeInClosedWorkloadNeedsToBeSpecified constraint of '<em>Closed Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String CLOSED_WORKLOAD_TYPE__THINK_TIME_IN_CLOSED_WORKLOAD_NEEDS_TO_BE_SPECIFIED__EEXPRESSION = "not self.thinkTime.oclIsUndefined() and not self.thinkTime.probFunction.oclIsUndefined()";

	/**
	 * Validates the thinkTimeInClosedWorkloadNeedsToBeSpecified constraint of '<em>Closed Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateClosedWorkloadType_thinkTimeInClosedWorkloadNeedsToBeSpecified(ClosedWorkloadType closedWorkloadType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(WorkloadPackage.Literals.CLOSED_WORKLOAD_TYPE,
				 closedWorkloadType,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "thinkTimeInClosedWorkloadNeedsToBeSpecified",
				 CLOSED_WORKLOAD_TYPE__THINK_TIME_IN_CLOSED_WORKLOAD_NEEDS_TO_BE_SPECIFIED__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the populationInClosedWorkloadNeedsToBeGreaterThanZero constraint of '<em>Closed Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String CLOSED_WORKLOAD_TYPE__POPULATION_IN_CLOSED_WORKLOAD_NEEDS_TO_BE_GREATER_THAN_ZERO__EEXPRESSION = "self.population > 0";

	/**
	 * Validates the populationInClosedWorkloadNeedsToBeGreaterThanZero constraint of '<em>Closed Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateClosedWorkloadType_populationInClosedWorkloadNeedsToBeGreaterThanZero(ClosedWorkloadType closedWorkloadType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(WorkloadPackage.Literals.CLOSED_WORKLOAD_TYPE,
				 closedWorkloadType,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "populationInClosedWorkloadNeedsToBeGreaterThanZero",
				 CLOSED_WORKLOAD_TYPE__POPULATION_IN_CLOSED_WORKLOAD_NEEDS_TO_BE_GREATER_THAN_ZERO__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAbstractUserAction(AbstractUserAction abstractUserAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(abstractUserAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLoopUserAction(LoopUserAction loopUserAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(loopUserAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDelayUserAction(DelayUserAction delayUserAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(delayUserAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBranchUserAction(BranchUserAction branchUserAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(branchUserAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateEntryLevelSystemCall(EntryLevelSystemCall entryLevelSystemCall, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(entryLevelSystemCall, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCallParameterSetting(CallParameterSetting callParameterSetting, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(callParameterSetting, diagnostics, context);
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //WorkloadValidator
